<template>
  <v-container fluid class="mt-16">
    <BackNavigator />

    <!--Start Loading progress bar ------------------------------------------------------->
    <Loading v-if="is_loading" :loading="is_loading" />
    <!--End   Loading progress bar ------------------------------------------------------->

    <v-row
      v-if="Boolean(country)"
      class="d-flex justify-center align-content-center px-0 mt-16"
    >
      <!--Start country flag image  --------------------------------------------------------->
      <v-col cols="12" lg="6" class="fill-height px-0">
        <v-img max-width="600" aspect-ratio="1.33" :src="country.flag"></v-img>
      </v-col>
      <!--End   country flag image  --------------------------------------------------------->

      <!--Start Specifications      --------------------------------------------------------->
      <v-col cols="12" lg="6" class="fill-height pt-10 spec-container">
        <h1>{{ country.name }}</h1>

        <!--Start Country info      --------------------------------------->
        <CountrySubInfo :country="country" />
        <!--End   Country info      --------------------------------------->

        <!--Start Border Countries  --------------------------------------->
        <CountryBorderList :border-countries="country.borders" />
        <!--End   Border Countries  --------------------------------------->
      </v-col>
      <!--End   Specifications      --------------------------------------------------------->
    </v-row>

    <!--Start NO DATA              ------------------------------------------------------->
    <h1 v-else-if="!is_loading" class="text-center text-uppercase">
      {{ $_t("components.countries.detail.country_info.not_found") }}
    </h1>
    <!--Start NO DATA              ------------------------------------------------------->
  </v-container>
</template>

<script>
import BackNavigator from "@/components/app/BackNavigator";
import CountryBorderList from "@/components/countries/detail/CountryBorderList";
import { mapActions, mapGetters } from "vuex";
import Loading from "@/components/app/Loading";
import CountrySubInfo from "@/components/countries/detail/CountrySubInfo";
export default {
  name: "CountryInfo",
  components: { CountrySubInfo, Loading, CountryBorderList, BackNavigator },
  data() {
    return {
      RETURNED_FIELDS: [
        "name",
        "nativeName",
        "capital",
        "population",
        "region",
        "flag",
        "alpha3Code",
        "borders",
        "subregion",
        "topLevelDomain",
        "languages",
        "currencies",
      ],
    };
  },
  computed: {
    ...mapGetters({
      is_loading: "loading/is_loading",

      country: "countries/country",
    }),
  },
  methods: {
    ...mapActions({
      fetchCountryByCode: "countries/fetchCountryByCode",

      /* loading handlers */
      startLoading: "loading/start",
      finishLoading: "loading/finish",
    }),

    initialize() {
      this.startLoading();
      this.fetchCountryByCode({
        code: this.$route.params.id,
        config: this.RETURNED_FIELDS,
      }).finally(() => {
        this.finishLoading();
      });
    },
  },
  created() {
    if (this.$route.params.id) this.initialize();
    else this.$_backNavigator();
  },
};
</script>

<style scoped></style>
